package org.bitbucket.bradleysmithllc.etlunit.feature.database;

import org.bitbucket.bradleysmithllc.etlunit.io.file.DataFileSchema;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestValueObject;

import java.io.File;
import java.io.IOException;

public interface DatabaseRuntimeSupport
{
	File getSourceDataDirectoryForCurrentTest();
	File getSourceScriptsDirectoryForCurrentTest();
	File getSourceDataSetForCurrentTest(String dataSetName);
	File getSourceScriptForCurrentTest(String scriptName);

	File getSourceDataDirectory(String package_);
	File getSourceScriptsDirectory(String package_);
	File getSourceDataSet(String package_, String dataSetName);
	File getSourceScript(String package_, String scriptName);

	File getCachedMetaData(DatabaseConnection conn);
	File getGeneratedSourceDirectory(DatabaseConnection conn, String mode);
	File getGeneratedDataSet(DatabaseConnection conn, String mode, String dataSetName);

	DataFileSchema createRelationalMetaInfo(DatabaseConnection dbConn, String schema, String name);
	DataFileSchema createRelationalMetaInfo(String connectionId, String schema, String name);

	DataFileSchema getRelationalMetaInfo(DatabaseConnection dbConn, String schema, String name, String masterName, ETLTestValueObject etlObj);
	DataFileSchema getRelationalMetaInfo(String connectionId, String schema, String name, String masterName, ETLTestValueObject etlObj);

	void persistDataFileSchema(DataFileSchema schema) throws IOException;
}